Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition not_eq_S : forall (n:nat), forall (m:nat), (connectives.Not (logic.eq (nat) n m)) -> connectives.Not (logic.eq (nat) (S n) (S m)) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (logic.eq (nat) n m)) => (((((logic.not_to_not) (logic.eq (nat) (S n) (S m))) (logic.eq (nat) n m)) (fun (auto':logic.eq (nat) (S n) (S m)) => (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (nat) __ m)) (((logic.refl) (nat)) (m))) (n)) (((((((logic.rewrite_r) (nat)) (pred (S n))) (fun (__:nat) => logic.eq (nat) m __)) (((((((logic.rewrite_r) (nat)) (S m)) (fun (__:nat) => logic.eq (nat) m (pred __))) ((pred_Sn) (m))) (S n)) (auto'))) (n)) ((pred_Sn) (n)))))) (auto)).
Definition not_eq_O_S : forall (n:nat), connectives.Not (logic.eq (nat) O (S n)) := fun (n:nat) => ((connectives.nmk) (logic.eq (nat) O (S n))) (fun (eqOS:logic.eq (nat) O (S n)) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) (((((((logic.eq_ind_r) (nat)) (S n)) (fun (x:nat) => not_zero x)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (O)) (eqOS)))).
Definition lt_to_not_zero : forall (n:nat), forall (m:nat), (lt n m) -> not_zero m := fun (n:nat) => fun (m:nat) => fun (Hlt:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => not_zero x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:not_zero m0) => (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (m0)) (fun (y:Prop) => y)) (connectives.I))))) (m)) (Hlt)).
Definition le_S_S : forall (n:nat), forall (m:nat), (le n m) -> le (S n) (S m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (S n) (S x_417))) ((le_n) (S n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (S n) (S m0)) => ((((le_S) (S n)) (S m0)) (_x_421))))) (m)) (lenm)).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition not_le_Sn_O : forall (n:nat), connectives.Not (le (S n) O) := fun (n:nat) => ((connectives.nmk) (le (S n) O)) (fun (Hlen0:le (S n) O) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) ((((lt_to_not_zero) (n)) (O)) (Hlen0)))).
Definition not_le_to_not_le_S_S : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> connectives.Not (le (S n) (S m)) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (le n m)) => (((((logic.not_to_not) (le (S n) (S m))) (le n m)) (fun (auto':le (S n) (S m)) => (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n)))))) (auto)).
Definition not_le_Sn_n : forall (n:nat), connectives.Not (le (S n) n) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => connectives.Not (le (S _x_365) _x_365))) ((not_le_Sn_O) (O))) (fun (x_366:nat) => fun (_x_368:connectives.Not (le (S x_366) x_366)) => ((((not_le_to_not_le_S_S) (S x_366)) (x_366)) (_x_368)))) (n).
Definition lt_to_not_eq : forall (n:nat), forall (m:nat), (lt n m) -> connectives.Not (logic.eq (nat) n m) := fun (n:nat) => fun (m:nat) => fun (H:lt n m) => (((((logic.not_to_not) (logic.eq (nat) n m)) (connectives.False)) (fun (auto:logic.eq (nat) n m) => ((((logic.absurd) (le (S n) n)) (((((logic.eq_coerc) (le (S n) m)) (le (S n) n)) (H)) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le (S n) __) (le (S n) n))) (((logic.refl) (Prop)) (le (S n) n))) (m)) (auto)))) ((not_le_Sn_n) (n))))) (((connectives.nmk) (connectives.False)) (fun (auto:connectives.False) => (auto)))).
Parameter eqb : nat -> nat -> bool.bool.
Parameter eqb_body : nat -> nat -> bool.bool.
Axiom axiom_eqb : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n).
Definition eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((axiom_eqb) (n)).
Definition sym_eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (filter_nat_type (nat -> bool.bool) eqb_body n) (eqb n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((eq_eqb) (n)).
Axiom axiom_eqb_body_O : connectives.equal (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m).
Definition eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) := ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (axiom_eqb_body_O).
Definition sym_eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) (eqb_body O) := ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (eq_eqb_body_O).
Axiom axiom_eqb_body_S : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m).
Definition eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((axiom_eqb_body_S) (n)).
Definition sym_eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) (eqb_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((eq_eqb_body_S) (n)).
Definition eqb_elim : forall (n:nat), forall (m:nat), forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) __ _0) -> P bool.true) -> ((connectives.Not (logic.eq (nat) __ _0)) -> P bool.false) -> P (eqb __ _0))) (fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O __) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O __)) -> P bool.false) -> P (eqb O __))) ((((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto:(logic.eq (nat) O O) -> P bool.true) => (fun (auto':(connectives.Not (logic.eq (nat) O O)) -> P bool.false) => ((auto) (((logic.refl) (nat)) (O)))))))))) (fun (auto:nat) => (((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (auto)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto':(logic.eq (nat) O (S auto)) -> P bool.true) => (fun (auto'':(connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) => ((auto'') ((not_eq_O_S) (auto)))))))))) (n))) (fun (n:nat) => (((sym_eq_eqb) (S n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((sym_eq_eqb_body_S) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.false)) (fun (q:nat) => eqb n q)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto:(logic.eq (nat) (S n) O) -> P bool.true) => (fun (auto':(connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) => ((auto') (((((logic.sym_not_eq) (nat)) (O)) (S n)) ((not_eq_O_S) (n))))))))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_eqb) (S n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((sym_eq_eqb_body_S) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.false)) (fun (q:nat) => eqb n q)) (m)) (fun (y:bool.bool) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P y)) (fun (auto:forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) => (fun (P:bool.bool -> Prop) => fun (auto':(logic.eq (nat) (S n) (S m)) -> P bool.true) => (fun (auto'':(connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) => ((((auto) (P)) (fun (auto''':logic.eq (nat) n m) => ((auto') (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) (S n) (S __))) (((logic.refl) (nat)) (S n))) (m)) (auto'''))))) (fun (auto''':connectives.Not (logic.eq (nat) n m)) => ((auto'') ((((not_eq_S) (n)) (m)) (auto''')))))))))))).
Definition eqb_n_n : forall (n:nat), logic.eq (bool.bool) (eqb n n) bool.true := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (bool.bool) (eqb _x_365 _x_365) bool.true)) ((((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (fun (y:bool.bool) => logic.eq (bool.bool) y bool.true)) (((logic.refl) (bool.bool)) (bool.true))))))) (fun (x_366:nat) => (((sym_eq_eqb) (S x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) ((((sym_eq_eqb_body_S) (x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.false)) (fun (q:nat) => eqb x_366 q)) (x_366)) (fun (y:bool.bool) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) y bool.true)) (fun (_x_368:logic.eq (bool.bool) (eqb x_366 x_366) bool.true) => (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (eqb x_366 x_366)) (_x_368)))))))) (n).
Definition not_eq_to_eqb_false : forall (n:nat), forall (m:nat), (connectives.Not (logic.eq (nat) n m)) -> logic.eq (bool.bool) (eqb n m) bool.false := fun (n:nat) => fun (m:nat) => fun (noteq:connectives.Not (logic.eq (nat) n m)) => ((((((eqb_elim) (n)) (m)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.false)) (fun (Heq:logic.eq (nat) n m) => (((connectives.falsity) (logic.eq (bool.bool) bool.true bool.false)) ((((logic.absurd) (logic.eq (nat) n m)) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) n __)) (((logic.refl) (nat)) (n))) (m)) (Heq))) (noteq))))) (fun (auto:connectives.Not (logic.eq (nat) n m)) => (((logic.refl) (bool.bool)) (bool.false)))).
