Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Definition injn : (nat.nat -> nat.nat) -> nat.nat -> Prop := fun (f:(nat.nat -> nat.nat)) => fun (n:nat.nat) => forall (i:nat.nat), forall (j:nat.nat), (nat.le i n) -> (nat.le j n) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j.
Definition injn_Sn_n : forall (f:(nat.nat -> nat.nat)), forall (n:nat.nat), (injn f (nat.S n)) -> injn f n := fun (f:nat.nat -> nat.nat) => fun (n:nat.nat) => fun (H:injn f (nat.S n)) => (fun (i:nat.nat) => fun (j:nat.nat) => fun (lei:nat.le i n) => (fun (lej:nat.le j n) => (fun (eqf:logic.eq (nat.nat) (f i) (f j)) => ((((((H) (i)) (j)) ((((nat.le_S) (i)) (n)) (lei))) ((((nat.le_S) (j)) (n)) (lej))) (((((((logic.rewrite_l) (nat.nat)) (f i)) (fun (__:nat.nat) => logic.eq (nat.nat) (f i) __)) (((logic.refl) (nat.nat)) (f i))) (f j)) (eqf)))))).
Parameter invert_permut : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Parameter invert_permut_body : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Axiom axiom_invert_permut : forall (n:nat.nat), connectives.equal ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut n) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n).
Definition eq_invert_permut : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut n) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n) := fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut n)) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n)) ((axiom_invert_permut) (n)).
Definition sym_eq_invert_permut : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n) (invert_permut n) := fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut n)) (nat.filter_nat_type ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) invert_permut_body n)) ((eq_invert_permut) (n)).
Axiom axiom_invert_permut_body_O : connectives.equal ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body nat.O) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) nat.O nat.O (nat.eqb m (f nat.O))).
Definition eq_invert_permut_body_O : leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body nat.O) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) nat.O nat.O (nat.eqb m (f nat.O))) := ((((connectives.equal_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body nat.O)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) nat.O nat.O (nat.eqb m (f nat.O)))) (axiom_invert_permut_body_O).
Definition sym_eq_invert_permut_body_O : leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) nat.O nat.O (nat.eqb m (f nat.O))) (invert_permut_body nat.O) := ((((leibniz.sym_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body nat.O)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) nat.O nat.O (nat.eqb m (f nat.O)))) (eq_invert_permut_body_O).
Axiom axiom_invert_permut_body_S : forall (n:nat.nat), connectives.equal ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body (nat.S n)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n)))).
Definition eq_invert_permut_body_S : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body (nat.S n)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n)))) := fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body (nat.S n))) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n))))) ((axiom_invert_permut_body_S) (n)).
Definition sym_eq_invert_permut_body_S : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n)))) (invert_permut_body (nat.S n)) := fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body (nat.S n))) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n))))) ((eq_invert_permut_body_S) (n)).
Definition invert_permut_f : forall (f:(nat.nat -> nat.nat)), forall (n:nat.nat), forall (m:nat.nat), (nat.le m n) -> (injn f n) -> logic.eq (nat.nat) (invert_permut n f (f m)) m := fun (f:nat.nat -> nat.nat) => fun (n:nat.nat) => fun (m:nat.nat) => fun (lenm:nat.le m n) => (((((((nat.le_ind) (m)) (fun (x_417:nat.nat) => (injn f x_417) -> logic.eq (nat.nat) (invert_permut x_417 f (f m)) m)) (((((nat.match_nat_prop) (fun (__:nat.nat) => (injn f __) -> logic.eq (nat.nat) (invert_permut __ f (f __)) __)) ((((sym_eq_invert_permut) (nat.O)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f nat.O) -> logic.eq (nat.nat) (y f (f nat.O)) nat.O)) (((((nat.sym_eq_filter_nat_type_O) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f nat.O) -> logic.eq (nat.nat) (y f (f nat.O)) nat.O)) (((sym_eq_invert_permut_body_O) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f nat.O) -> logic.eq (nat.nat) (y f (f nat.O)) nat.O)) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => (forall (i:nat.nat), forall (j:nat.nat), (nat.le i nat.O) -> (nat.le j nat.O) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j) -> logic.eq (nat.nat) (bool.match_bool_type (nat.nat) nat.O nat.O x) nat.O)) (fun (auto:forall (i:nat.nat), forall (j:nat.nat), (nat.le i nat.O) -> (nat.le j nat.O) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j) => ((((((bool.eq_match_bool_type_true) (nat.nat)) (nat.O)) (nat.O)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) nat.O nat.O bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) nat.O nat.O bool.true))))) (nat.eqb (f nat.O) (f nat.O))) ((nat.eqb_n_n) (f nat.O))))))) (fun (a:nat.nat) => (((sym_eq_invert_permut) (nat.S a)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f (nat.S a)) -> logic.eq (nat.nat) (y f (f (nat.S a))) (nat.S a))) ((((((nat.sym_eq_filter_nat_type_S) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body)) (a)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f (nat.S a)) -> logic.eq (nat.nat) (y f (f (nat.S a))) (nat.S a))) ((((sym_eq_invert_permut_body_S) (a)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (injn f (nat.S a)) -> logic.eq (nat.nat) (y f (f (nat.S a))) (nat.S a))) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => (forall (i:nat.nat), forall (j:nat.nat), (nat.le i (nat.S a)) -> (nat.le j (nat.S a)) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j) -> logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (nat.S a) (invert_permut a f (f (nat.S a))) x) (nat.S a))) (fun (auto:forall (i:nat.nat), forall (j:nat.nat), (nat.le i (nat.S a)) -> (nat.le j (nat.S a)) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j) => ((((((bool.eq_match_bool_type_true) (nat.nat)) (nat.S a)) (invert_permut a f (f (nat.S a)))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (nat.S a) (invert_permut a f (f (nat.S a))) bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (nat.S a) (invert_permut a f (f (nat.S a))) bool.true))))) (nat.eqb (f (nat.S a)) (f (nat.S a)))) ((nat.eqb_n_n) (f (nat.S a)))))))) (m))) (fun (m0:nat.nat) => (((sym_eq_invert_permut) (nat.S m0)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (nat.le m m0) -> ((injn f m0) -> logic.eq (nat.nat) (invert_permut m0 f (f m)) m) -> (injn f (nat.S m0)) -> logic.eq (nat.nat) (y f (f m)) m)) ((((((nat.sym_eq_filter_nat_type_S) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body)) (m0)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (nat.le m m0) -> ((injn f m0) -> logic.eq (nat.nat) (invert_permut m0 f (f m)) m) -> (injn f (nat.S m0)) -> logic.eq (nat.nat) (y f (f m)) m)) ((((sym_eq_invert_permut_body_S) (m0)) (fun (y:((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) => (nat.le m m0) -> ((injn f m0) -> logic.eq (nat.nat) (invert_permut m0 f (f m)) m) -> (injn f (nat.S m0)) -> logic.eq (nat.nat) (y f (f m)) m)) (fun (lem:nat.le m m0) => (fun (H:(injn f m0) -> logic.eq (nat.nat) (invert_permut m0 f (f m)) m) => (fun (H1:injn f (nat.S m0)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (nat.S m0) (invert_permut m0 f (f m)) x) m)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (nat.S m0)) (invert_permut m0 f (f m))) (fun (y:nat.nat) => logic.eq (nat.nat) y m)) ((H) ((((injn_Sn_n) (f)) (m0)) (H1))))) (nat.eqb (f m) (f (nat.S m0)))) ((((nat.not_eq_to_eqb_false) (f m)) (f (nat.S m0))) (((connectives.nmk) (logic.eq (nat.nat) (f m) (f (nat.S m0)))) (fun (eqf:logic.eq (nat.nat) (f m) (f (nat.S m0))) => ((((logic.absurd) (logic.eq (nat.nat) m (nat.S m0))) ((((((H1) (m)) (nat.S m0)) ((((nat.le_S) (m)) (m0)) (lem))) ((nat.le_n) (nat.S m0))) (((((((logic.rewrite_l) (nat.nat)) (f m)) (fun (__:nat.nat) => logic.eq (nat.nat) (f m) __)) (((logic.refl) (nat.nat)) (f m))) (f (nat.S m0))) (eqf)))) ((((nat.lt_to_not_eq) (m)) (nat.S m0)) ((((nat.le_S_S) (m)) (m0)) (lem))))))))))))))) (n)) (lenm)).
